package be.iminds.ilabt.jfed.espec.model;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * UploadSpec
 */
public class ExecuteSpec {
    @Nonnull private final FileSource source;
    @Nullable private final String path;
    @Nullable private final String pwd;
    @Nonnull private final String permissions;
    @Nullable private final List<String> nodes;

    public ExecuteSpec(@Nonnull FileSource source,
                       @Nullable String path,
                       @Nullable String pwd,
                       @Nullable String permissions,
                       @Nullable List<String> nodes) {
        this.source = source;
        this.path = path;
        this.pwd = pwd;
        this.permissions = permissions == null ? "u=rwx" : permissions;
        this.nodes = nodes;
    }

    @Nonnull
    public FileSource getSource() {
        return source;
    }

    @Nullable
    public String getPath() {
        return path;
    }

    @Nullable
    public String getPwd() {
        return pwd;
    }

    @Nonnull
    public String getPermissions() {
        return permissions;
    }

    @Nullable
    public List<String> getNodes() {
        return nodes;
    }
}
